/* 
modified for INOVA 08/11/2017 Peter

Pulse sequence of 1D interferogram pure shift experiments using TSE-PSYCHE
Peter Kiraly

----------------------
Developed By NMR Group
School of Chemistry
University of Manchester
United Kingdom
Aug 2017
----------------------
*/

#include <standard.h>
static int	ph1[8] = {0,2, 0,2, 1,3,1,3},	
		ph2[8] = {0,0, 0,0, 0,0,0,0},
		ph3[8] = {0,0, 1,1, 0,0,1,1},
		ph4[8] = {0,0, 0,0, 0,0,0,0},
		ph5[8] = {0,2, 2,0, 1,3,3,1};
pulsesequence()
{	
double	rof3 = getval("rof3"),	
	tau_a = getval("tau_a"),
	tpwr = getval("tpwr"),
	pw = getval("pw"),
	pw180_bb = getval("pw180_bb"),
	pwr180_bb = getval("pwr180_bb"),
	pw180_a = getval("pw180_a"),
	pwr180_a = getval("pwr180_a"),
	hsgt = getval("hsgt"),
	hsglvl = getval("hsglvl"),
	gstab = getval("gstab"),
	gt1 = getval("gt1"),  
	gzlvl1 = getval("gzlvl1"),
	gzlvl3 = getval("gzlvl3"),
	gt2 = getval("gt2"),  
	gzlvl2 = getval("gzlvl2"),
	gzlvl7 = getval("gzlvl7"),	
	gzlvl8 = getval("gzlvl8"),	
	sw1 = getval("sw1"),		
	droppts = getval("droppts");	
int 	kpph = getval("kpph");	
char	sspul[MAXSTR],
	shp_a[MAXSTR], shp_bb[MAXSTR], shp_bbR[MAXSTR];
  
	getstr("sspul",sspul);
	getstr("shp_a",shp_a);
	getstr("shp_bb",shp_bb);
	getstr("shp_bbR",shp_bbR);        


if ((kpph<0) || (kpph>8))
{
abort_message("Number of steps for phase cycling is incorrect..change kpph..");
}
if ((fmod(droppts,2))!=0.0)
{
abort_message("droppts must be an integer multiple of 2..");
}
if ( (0.25/sw1-gt1-gstab) < 0.0)
{
abort_message("chunktime is too short to accomodate gt1/gstab..");
}
if ((tau_a-rof1-gt2-gstab)<0.0)
{
abort_message("tau_a is too short to accomodate gt2/gstab..");
}
if ( (fmod(sw/sw1,1)) !=0.0)
{
abort_message("sw1 must be an integer submultiple of sw..");
}
if (kpph==0)
{
	settable(t1,8,ph1);
	settable(t2,8,ph2);
	settable(t3,8,ph3);
	settable(t5,8,ph5);
}
else
{
	settable(t1,kpph,ph1);
	settable(t2,kpph,ph2);
	settable(t3,kpph,ph3);
	settable(t5,kpph,ph5);
}
	sub(ct, ssctr, v20);
	getelem(t1, v20, v1);
	getelem(t2, v20, v2);
	getelem(t3, v20, v3);
	getelem(t5, v20, oph);
status(A);
	txphase(zero);
        obsoffset(tof);
	obspower(tpwr);
	obspwrf(tpwrf);
	delay(0.001);
	if (sspul[0]=='y') 
	{
	zgradpulse(hsglvl,hsgt); 
	delay(gstab);
	rgpulse(pw,zero,rof1,rof1);
	zgradpulse(hsglvl,hsgt); 
	delay(0.05);
	}
	delay(d1);
status(B);
	rgpulse(pw,v1,rof1,0.0);
	delay(droppts/sw);
	obspower(pwr180_bb);
	delay(0.25/sw1 -POWER_DELAY);
	zgradpulse(gzlvl1,gt1);
	delay(gstab);
	rgradient('z',gzlvl8);
	shaped_pulse(shp_bb,pw180_bb,v2,rof1,rof1);
	rgradient('z',0.0);
	zgradpulse(gzlvl1,gt1);
	delay(gstab);
	obspower(pwr180_a);
	delay(0.25/sw1 -POWER_DELAY);
	delay(d2/2.0);
	delay(tau_a-rof1-gt2-gstab);
	zgradpulse(gzlvl2,gt2);
	delay(gstab);
	rgradient('z',gzlvl7);
	shaped_pulse(shp_a,pw180_a,v3,rof1,rof1);
	rgradient('z',0.0);
	if ((tau_a-rof1-gt2-gstab) > gstab)
	{
        delay(gstab);
	zgradpulse(gzlvl2,gt2);
	delay(tau_a-rof1-gt2-gstab);
	}
	else
	{
	delay(tau_a-rof1-gt2-gstab);
	zgradpulse(gzlvl2,gt2);
        delay(gstab);
	}
	obspower(pwr180_bb);
	zgradpulse(gzlvl3,gt1);
	delay(gstab-POWER_DELAY+rof2);
	rgradient('z',gzlvl8);
	shaped_pulse(shp_bbR,pw180_bb,v4,rof1,rof1);
	rgradient('z',0.0);
	delay(rof1);
	zgradpulse(gzlvl3,gt1);
	delay(gstab-rof1);
delay(d2/2.0);

status(C);
}



